var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var env_exports = {};
__export(env_exports, {
  canUseNpm: () => canUseNpm,
  canUseNvm: () => canUseNvm,
  canUsePnpm: () => canUsePnpm,
  canUseYarn: () => canUseYarn
});
module.exports = __toCommonJS(env_exports);
var import_utils = require("@modern-js/utils");
async function canUseNvm() {
  try {
    await (0, import_utils.execa)("source ~/.nvm/nvm.sh", {
      env: process.env,
      shell: true
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUseNpm() {
  try {
    await (0, import_utils.execa)("npm", ["--version"], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUseYarn() {
  try {
    await (0, import_utils.execa)("yarn", ["--version"], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
async function canUsePnpm() {
  try {
    await (0, import_utils.execa)("pnpm", ["--version"], {
      env: process.env
    });
    return true;
  } catch (e) {
    return false;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  canUseNpm,
  canUseNvm,
  canUsePnpm,
  canUseYarn
});
