function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
var __generator = this && this.__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
import { execa } from "@modern-js/utils";
import { canUseNpm, canUsePnpm, canUseYarn } from "./env";
function execaWithStreamLog(command, args, options) {
    var promise = execa(command, args, _objectSpreadProps(_objectSpread({}, options), {
        stdin: "inherit",
        stdout: "inherit",
        stderr: "inherit"
    }));
    return promise;
}
function runInstallWithNvm(command, options) {
    return _runInstallWithNvm.apply(this, arguments);
}
function _runInstallWithNvm() {
    _runInstallWithNvm = _asyncToGenerator(function(command, options) {
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        execa("~/.nvm/nvm-exec ".concat(command), _objectSpreadProps(_objectSpread({}, options), {
                            shell: true,
                            stdin: "inherit",
                            stdout: "inherit",
                            stderr: "inherit"
                        }))
                    ];
                case 1:
                    _state.sent();
                    return [
                        2
                    ];
            }
        });
    });
    return _runInstallWithNvm.apply(this, arguments);
}
function npmInstall(_) {
    return _npmInstall.apply(this, arguments);
}
function _npmInstall() {
    _npmInstall = _asyncToGenerator(function(param) {
        var cwd, registryUrl, ignoreScripts, useNvm, canUse, params;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    cwd = param.cwd, registryUrl = param.registryUrl, ignoreScripts = param.ignoreScripts, useNvm = param.useNvm;
                    return [
                        4,
                        canUseNpm()
                    ];
                case 1:
                    canUse = _state.sent();
                    if (canUse) {
                        params = [
                            "install"
                        ];
                        if (registryUrl) {
                            params.push("--registry=".concat(registryUrl));
                        }
                        if (ignoreScripts) {
                            params.push("--ignore-scripts");
                        }
                        if (useNvm) {
                            return [
                                2,
                                runInstallWithNvm("npm ".concat(params.join(" ")), {
                                    cwd: cwd,
                                    env: process.env
                                })
                            ];
                        }
                        return [
                            2,
                            execaWithStreamLog("npm", params, {
                                cwd: cwd,
                                env: process.env
                            })
                        ];
                    }
                    throw new Error("please install npm first");
            }
        });
    });
    return _npmInstall.apply(this, arguments);
}
function yarnInstall(_) {
    return _yarnInstall.apply(this, arguments);
}
function _yarnInstall() {
    _yarnInstall = _asyncToGenerator(function(param) {
        var cwd, registryUrl, ignoreScripts, useNvm, canUse, params;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    cwd = param.cwd, registryUrl = param.registryUrl, ignoreScripts = param.ignoreScripts, useNvm = param.useNvm;
                    return [
                        4,
                        canUseYarn()
                    ];
                case 1:
                    canUse = _state.sent();
                    if (canUse) {
                        params = [
                            "install"
                        ];
                        if (registryUrl) {
                            params.push("--registry=".concat(registryUrl));
                        }
                        if (ignoreScripts) {
                            params.push("--ignore-scripts");
                        }
                        if (useNvm) {
                            return [
                                2,
                                runInstallWithNvm("yarn ".concat(params.join(" ")), {
                                    cwd: cwd,
                                    env: process.env
                                })
                            ];
                        }
                        return [
                            2,
                            execaWithStreamLog("yarn", params, {
                                cwd: cwd,
                                env: process.env
                            })
                        ];
                    }
                    throw new Error("please install yarn first");
            }
        });
    });
    return _yarnInstall.apply(this, arguments);
}
function pnpmInstall(_) {
    return _pnpmInstall.apply(this, arguments);
}
function _pnpmInstall() {
    _pnpmInstall = _asyncToGenerator(function(param) {
        var cwd, registryUrl, ignoreScripts, useNvm, canUse, params;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    cwd = param.cwd, registryUrl = param.registryUrl, ignoreScripts = param.ignoreScripts, useNvm = param.useNvm;
                    return [
                        4,
                        canUsePnpm()
                    ];
                case 1:
                    canUse = _state.sent();
                    if (canUse) {
                        params = [
                            "install"
                        ];
                        if (registryUrl) {
                            params.push("--registry=".concat(registryUrl));
                        }
                        if (ignoreScripts) {
                            params.push("--ignore-scripts");
                        }
                        if (useNvm) {
                            return [
                                2,
                                runInstallWithNvm("yarn ".concat(params.join(" ")), {
                                    cwd: cwd,
                                    env: process.env
                                })
                            ];
                        }
                        return [
                            2,
                            execaWithStreamLog("pnpm", params, {
                                cwd: cwd,
                                env: process.env
                            })
                        ];
                    }
                    throw new Error("please install pnpm first");
            }
        });
    });
    return _pnpmInstall.apply(this, arguments);
}
export { execaWithStreamLog, npmInstall, pnpmInstall, runInstallWithNvm, yarnInstall };
